#
#  AppController.rb
#  GPSMinna
#
#  Created by Heiko Kretschmer on 2008.
#  Copyright (c) 2008 Heiko Kretschmer. All rights reserved.
#

# Requirements (was ist der Unterschied zu Includes?)
require 'osx/cocoa'
require 'Date'		# fuer DateTime
require 'fileutils' # fuer File.exectable and friends
require 'Defines.rb'
require 'RobAnybody.rb' # Require here, so that it can be included below

####################################
# Klasse "AppController"           #
class AppController < OSX::NSObject

####################################
# Includes (of Classes)            #
include		OSX
include		RobAnybody

####################################
# Outlets                          #
ib_outlets :window, :statusLabel, :cachesTableView, :cacheDetailTextView, :splitView, :cachesDataSource, :progressIndicator, :removeButton, :actionButton #, :mainMenuScriptsMenu  #, :exportToDevicePushButton, :importGPXFromMailPushButton  :exportToExcelPushButton, 
 
####################################
# Globals                          #
$globals = Hash.new
#$globals ["debug"] = 1			# Debug = ENABLED
#$globals ["debug"] = 0         # Debug = DISABLED
$globals ["deviceConnected"] = false # Das regelt der Thread (Timer)
$globals ["deviceConnectedOnLastCheck"] = false # Das regelt der Thread (Timer)
$globals ["statusLabelString"] = "" # Das regelt der Thread (Timer)
$globals ["statusLabelStringOld"] = "" # Das regelt der Thread (Timer)
$globals ["CachesDataSourceArray"] = NSMutableArray.alloc.init
$globals ["ImagesDataSourceArray"] = NSMutableArray.alloc.init
$globals ["statusItem"]	= false # Das Eigentliche Icon in der System-Status-Bar
$globals ["statusMenu"]	= false # Das Menü hinter dem Icon in der System-Status-Bar
$globals ["actionMenu"]	= false # Das Menü hinter dem Action Button
$globals ["scriptsMenuInStatusMenu"]	= false # Das Sub-Menü "Scripts" hinter dem Icon in der System-Status-Bar

# Import der DKActionButton Class
OSX.ns_import :DKActionButton
OSX.ns_import :DKActionButtonCell

####################################
# Methoden                         #

# AwakeFromNib
def awakeFromNib
	Say("AppCrt: Awaking from nib.")
	Say("AppCrt: self: %p", self)
 
	#Say(self.type.name + " ") # (von http://www.rubycentral.com/pickaxe/tut_modules.html)

 
	# Window config
	@window.setFrameAutosaveName("GPSMinnaWindow")

	# Erstmal alle Controls disablen
	Say("AppCrt: Disabling controls...")
#	enableControls(false)

	# Meine Application-Support-Folder anlegen
	Say("AppCrt: Creating necessary folders...")
    system("test ! -d ~/Documents/GPSMinna && mkdir ~/Documents/GPSMinna")
    system("test ! -d ~/Documents/GPSMinna/GPX && mkdir ~/Documents/GPSMinna/GPX")
    system("test ! -d ~/Documents/GPSMinna/Images && mkdir ~/Documents/GPSMinna/Images")
    system("test ! -d ~/Documents/GPSMinna/Tracklogs && mkdir ~/Documents/GPSMinna/Tracklogs")
    system("test ! -d ~/Documents/GPSMinna/Scripts && mkdir ~/Documents/GPSMinna/Scripts")

	# Device suchen via Timer, 10-sekündlich, der enabled/disabled dann die Controls
	#Say("AppCrt: Starting thread...")
	# brauch ich nicht mehr, da muessen die Scripts sich drum kümmern! startThread()

	# MenuItem erzeugen
	Say("AppCrt: Creating status menu...")
	initStatusMenu()
	Say("AppCrt: Creating status menu...done.")



	# Action Button init
	Say("AppCrt: Creating action menu...")
	$globals ["actionMenu"] = OSX::NSMenu.new().retain()
	Say("AppCrt: Adding blank menu item to action menu...")
	@item=$globals["actionMenu"].addItemWithTitle_action_keyEquivalent_("", nil, "")
	Say("AppCrt: Adding Scripts to menu...")
	
	Say("AppCrt: Adding action menu to cell...done.")
	@actionButton.cell().setMenu_($globals ["actionMenu"])
	Say("AppCrt: Creating action menu...done.")

	# Das Menu erzeugen 
#	$globals ["statusMenu"] = OSX::NSMenu.alloc.initWithTitle("")
 #   $globals ["statusMenu"].setAutoenablesItems(NO)
  #  $globals ["statusMenu"].retain
	#	# Menuitem #1: Show GPSMinna
	#	@item=$globals["statusMenu"].addItemWithTitle_action_keyEquivalent_("Show GPSMinna", :sendToForeground, "")
	#	@item.setEnabled(YES)


	# Preferences lesen
	Say("AppCrt: Reading preferences...")
	preferencesRead()
	
	# Preferences in window anzeigen
	Say("AppCrt: Applying preferences...")
	preferencesApply()
	
	# Da die Caches-Datasource via Outlet anscheinend seine datasource nicht bekommt, setze ich sie eben!
	Say("AppCrt: Reading gpx data into data source...")
	Say("awakeFromNib: %s", @cachesDataSource)
	if (!@cachesDataSource.tableView) then
		Say("TableView was nil, setting.")
		@cachesDataSource.setTableView(@cachesTableView)
	end

	# Mitbekommen, wenn wir im foreground sind
#	Say("Registering activate/deactivate Notifications...")
 #   OSX::NSNotificationCenter.defaultCenter.addObserver_selector_name_object_(self, :didActivate, OSX::NSApplicationDidBecomeActiveNotification, self)
  #  OSX::NSNotificationCenter.defaultCenter.addObserver_selector_name_object_(self, :willDeactivate, OSX::NSApplicationWillResignActiveNotification, self)
	#Say("Registering activate/deactivate Notifications...done")
 
	# Tableview reload
#	Say("AppCrt: Reloading DataSource & TableView...")
#	@cachesDataSource.reload()

	# Scripts Menu updaten 
	self.updateAllScriptsMenus()
	
end # of awakeFromNib

def applicationDidBecomeActive(aNotification)
	Say("didActivate!")
#	self.addKeyboardShortCutsToScriptsMenu($globals ["scriptsMenuInStatusMenu"], true)
	@window.makeKeyAndOrderFront_(self)
end # didActivate

def applicationWillResignActive(aNotification)
	Say("willDeactivate!")
#	self.addKeyboardShortCutsToScriptsMenu($globals ["scriptsMenuInStatusMenu"], false)
end # didDeactivate
	
# MenuItem erzeugen
def initStatusMenu()

	@bar = OSX::NSStatusBar.systemStatusBar
	$globals ["statusItem"] = @bar.statusItemWithLength(NSVariableStatusItemLength)
    $globals ["statusItem"].retain
    $globals ["statusItem"].setHighlightMode_(YES)

	# Das Menu erzeugen 
	$globals ["statusMenu"] = OSX::NSMenu.alloc.initWithTitle("")
    $globals ["statusMenu"].setAutoenablesItems(NO)
    $globals ["statusMenu"].retain
	
		# Menuitem #1: Show GPSMinna
		@item=$globals["statusMenu"].addItemWithTitle_action_keyEquivalent_("Show GPSMinna", :sendToForeground, "")
		@item.setEnabled(YES)

		# Menuitem #2: Separator/Divider
		$globals["statusMenu"].addItem(OSX::NSMenuItem.separatorItem)

		# Das Scripts-Submenu erzeugen 
		$globals ["scriptsMenuInStatusMenu"] = OSX::NSMenu.alloc.initWithTitle("Scripts")
		$globals ["scriptsMenuInStatusMenu"].setAutoenablesItems(NO)
		$globals ["scriptsMenuInStatusMenu"].retain
			
			# Scripts-Menu befüllen
#			self.updateScriptsMenu($globals ["scriptsMenuInStatusMenu"])
			
		# Menuitem #3: Scripts-SubMenu
		@item=$globals["statusMenu"].addItemWithTitle_action_keyEquivalent_("Scripts", nil, "")
		@item.setEnabled(YES)
		@item.setSubmenu_($globals ["scriptsMenuInStatusMenu"])

		# Image aus dem Bundle holen
		@thisBundle = OSX::NSBundle.mainBundle
		# Standard-Image
		@imagePathString=@thisBundle.pathForResource_ofType_("available", "tiff")
		Say("imagePathString: %s", @imagePathString.to_s)
		image = NSImage.alloc.initWithContentsOfFile(@imagePathString)
		if (image)
			$globals["statusItem"].setImage(image)
			image.release
		else
			Say("image path nil!")
		end # if
		# Selected-Image
		@imagePathString=@thisBundle.pathForResource_ofType_("available_selected", "tiff")
		image = NSImage.alloc.initWithContentsOfFile(@imagePathString)
		if (image)
			$globals["statusItem"].setAlternateImage(image)
			image.release
		else
			Say("image path nil!")
		end # if
			
		# Die View reloaden nach Image Change
		#$globals["statusItem"].view.setNeedsDisplay(YES)

		# Das Menu an den StatusItem dranklemmen */
		$globals ["statusItem"].setMenu($globals ["statusMenu"])
		Say("initStatusMenu done.")
end # def initStatusMenu

def updateScriptsMenuWithFolderContents(menu, folderPath, validsuffix)

	# Lesen des Verzeichnisses ins Array
	Say("Reading Script files in %s", folderPath)

	filesarray=Dir.entries(folderPath) # Den Verzeichnisinhalt in ein Ruby-Array schreiben
	for filename in filesarray
		Say("Processing file: " + filename)
		# Testen, ob die Files KEIN "." am Anfang und dafür ein "GPX" oder "gpx" am Ende haben!
		if (filename =~ /^\w+/) then # .-Files filtern, nur GPX ueberlassen
			# Wenn Filename mit "_" beginnt -> skippen.
			if (filename =~ /^_/) then
				Say("Skipping \"%s\", \"_\" indicates it's for GPSMinna's internal use only.", filename)
			else
				filecomparray=filename.split('.')
				prefix = filecomparray[0].upcase	# Filename ohne .Suffix
				suffix = filecomparray[1].downcase	# Suffix

				if (suffix == validsuffix) then
					Say("Adding file: %s", filename)

					# Dem Menu hinzufügen
					@item=menu.addItemWithTitle_action_keyEquivalent_(filename, :scriptMenuHit, "")
					@item.setEnabled(YES)
			#		@item.setTarget_(self)
			#		@item.setAction_(:scriptMenuHit(filename))
	#				@item.setAction_(scriptMenuHit(filename))
				else
					Say("%s might also not be a valid file. Skipping.", filename)
				end # if .gpx
			end # if ^_
		else
			Say("%s might not be a valid file. Skipping.", filename)
		end # if word-character
	end

end # updateScriptsMenuWithFolderContents

def scriptMenuHit(sender)
	Say("scriptMenuHit!")
	Say("scriptMenuHit: %s", sender)
	r=""
	
	# Titel (=Scriptname) des MenuItems = Filename holen...
	filename = sender.title.to_s
	
	# Progress Indicator starten
	@progressIndicator.startAnimation_(self)
	self.setStatusLabelValue("Executing " + filename + "...")
# macht thread	self.updateStatusLabel()
	
	# selektierte GPX-Namen übergeben
	if (@cachesDataSource and @cachesDataSource.tableView)
		numberOfRowsInTableView=@cachesDataSource.tableView.numberOfRows()
		maxRowI=numberOfRowsInTableView-1
		args=""
		for i in (0..maxRowI)
			selected=@cachesDataSource.tableView.isRowSelected(i)
			Say("Row %i 's selection-Flag is %i", i, selected)
			if (selected) then
				@gpxfilename	= @cachesDataSource.objectValueForTableColumnIdentifier_row_("Filename", i) # Ich bediene mich der vorh. accessors
				args = args + " " + "\"" + @gpxfilename.to_s + "\""
			end # if selected
		end # for
		
		# Lauch script
		r=runScript(filename, args)
		# Da wir ein Array von Zeilen zurückbekommen haben, dies nun in einen Einzeiler wandeln
		if (r.nitems > 0)
			statusMessage=r.join("; ")
		else
			statusMessage="Feeling good!"
		end

		# Tableview reload
		Say("scriptMenuHit: Reloading cachesDataSource %p", @cachesDataSource)
		@cachesDataSource.reload()
	end # if DS nil

	# Progress Indicator starten
	@progressIndicator.stopAnimation_(self)
	self.setStatusLabelValue(statusMessage)
#	self.setStatusLabelValue("Executing " + filename + " done: " + r)
# macht thread	self.updateStatusLabel()

end # scriptMenuHit

def updateAllScriptsMenus
	self.updateScriptsMenu($globals ["scriptsMenuInStatusMenu"], 0)		#	Das komplette Menu ersetzen
	self.updateScriptsMenu($globals ["actionMenu"], 1)					#	Den ersten Menuitem übrig lassen, braucht man für den DKActionButton
	self.addKeyboardShortCutsToScriptsMenu($globals ["actionMenu"], true, 1)
end # def updateAllScriptsMenus


def updateScriptsMenu(menu, firstItemToUpdate)

	# Erstmal Menu löschen 
	itemCount = menu.numberOfItems
	Say("items in scripts menu: %d", itemCount)
	if (itemCount > firstItemToUpdate)
		for i in (firstItemToUpdate..(itemCount-1))
			menu.removeItemAtIndex_(i)
		end
	end
	
	# Scripts in ~/Documents/GPSMinna/Scripts lesen	thisBundle	= OSX::NSBundle.mainBundle
#	username	= OSX::NSUserName()
#	formatPathToFolder=FOLDERSCRIPTS
#	@pathToScriptsFolder	= OSX::NSMutableString.alloc.initWithString("")
#	@pathToScriptsFolder.appendFormat(formatPathToFolder, username)
#	Say("pathToScriptsFolder: %s", @pathToScriptsFolder.to_s)
#	suffix="scpt" # Nur .scpt importen...
	self.updateScriptsMenuWithFolderContents(menu, getUserFolder(FOLDERSCRIPTS), "scpt")
	

	# Scripts in meiner App lesen
#	appScriptsPath=self.getBundlePath + "/Resources/Scripts"
#	Say("1appScriptsPath: %s", appScriptsPath)
	resourcePath=self.getResourcePath # + "/Scripts"
	Say("resourcePath: %s", resourcePath)
	#suffix= # Nur .scpt importen...
	self.updateScriptsMenuWithFolderContents(menu, resourcePath, "scpt")

end # updateScriptsMenu

def addKeyboardShortCutsToScriptsMenu(menu, flag, firstItemToUpdate)
	if (menu) then
		itemCount = menu.numberOfItems
		Say("items in scripts menu: %d", itemCount)
		if (flag == true) then	
			# Menu abklappern, Shortcuts setzen
			Say("Setting keyboard shortcuts...")
			if (itemCount > firstItemToUpdate)
				for i in (firstItemToUpdate..(itemCount-1))
					@menuItem = menu.itemAtIndex_(i)
					if ((i-firstItemToUpdate) < 9) then
						@menuItem.setKeyEquivalent_(((i-firstItemToUpdate)+1).to_s)
					elsif ((i-firstItemToUpdate) == 9) then
						@menuItem.setKeyEquivalent_(0.to_s)
					else
						# > 9 -> ignore
					end
				end
			end
		else
			Say("Removing keyboard shortcuts...")
			if (itemCount > 0)
				for i in (0..(itemCount-1))
					@menuItem = menu.itemAtIndex_(i)
					@menuItem.setKeyEquivalent_("")
				end
			end
		end
	end
end # addKeyboardShortCutsToScriptsMenu

# About Window
def aboutApp (sender)
	Say("Start")
	thisBundle = OSX::NSBundle.mainBundle
	copyrightString = thisBundle.objectForInfoDictionaryKey("CFBundleGetInfoString")
	versionString   = thisBundle.objectForInfoDictionaryKey("VersionString")
	Say("copyrightString: " + copyrightString)
	Say("versionString: " + versionString)
	Say("Narf")
	NSApp.orderFrontStandardAboutPanelWithOptions("Copyright" => copyrightString, "ApplicationVersion" => versionString)
	Say("End")
end # aboutApp 
ib_action :aboutApp

# Remove Button
def removeButtonHit (sender)
	Say("removeButtonHit hit!")
	
	# Selektierte GPX löschen
	if (@cachesDataSource and @cachesDataSource.tableView)
		pathGPXFolder		=	getUserFolder(FOLDERGPX)
		numberOfRowsInTableView=@cachesDataSource.tableView.numberOfRows()
		maxRowI=numberOfRowsInTableView-1
		args=""
		for i in (0..maxRowI)
			selected=@cachesDataSource.tableView.isRowSelected(i)
			Say("Row %i 's selection-Flag is %i", i, selected)
			if (selected) then
				@gpxfilename	= @cachesDataSource.objectValueForTableColumnIdentifier_row_("Filename", i) # Ich bediene mich der vorh. accessors
				gpxFilePath = pathGPXFolder + "/" + @gpxfilename.to_s
				system("rm \"" + gpxFilePath + "\"")
			end # if selected
		end # forend 
		
		# DS reloaden...
		@cachesDataSource.reload()

	end # if valid DS
end # removeButtonHit 
ib_action :removeButtonHit

# Action Button
def actionButtonHit (sender)
	Say("actionButtonHit hit!")
end # actionButtonHit 
ib_action :actionButtonHit

	def applicationDidFinishLaunching(notification)
        Say("Application finished launching")
	end

def sendToForeground(sender)
        Say("Application coming to front")
		OSX::NSApp.activateIgnoringOtherApps:YES # Verfahren aus Schick geklaut
end

# Will Terminate
def applicationWillTerminate (notification)
	Say("Will terminate.")
end
def applicationShouldTerminate (notification)
	Say("Should terminate.")
	# brauch ich nicht mehr, da muessen die Scripts sich drum kümmern! stopThread()
#	preferencesWrite()
	return NSTerminateNow
end

# Starten
def startThread()
	Say("startThread: Starting Thread.")
	if @thread == nil then
 	  $thread = Thread.new do
		loop do
			#deb Say("thread: %@", $thread)
			
			# Den vorherigen Zustand merken
#			oldStateString = $globals ["statusLabelString"]
			#Say("oldState: %s", oldState)
			
			# Falls Device angeschlossen -> status meldung anzeigen
			$globals ["deviceConnectedOnLastCheck"] = $globals ["deviceConnected"]
			$globals ["deviceConnected"] = system("test -d /Volumes/GARMIN") # Yeah, right. Forking a shell just to determine if folder is present.
			Say("startThread: deviceConnectedOnLastCheck: %s", $globals ["deviceConnectedOnLastCheck"])
			Say("startThread: deviceConnected: %s", $globals ["deviceConnected"])
			#Say("deviceConnected: %s", $globals ["deviceConnected"])
			#Say("deviceConnectedOnLastCheck: %s", $globals ["deviceConnectedOnLastCheck"])
			if ($globals ["deviceConnected"] != $globals ["deviceConnectedOnLastCheck"])
				Say("startThread: deviceConnected state changed!")
				if ($globals ["deviceConnected"] == true)
					#$globals ["statusLabelString"] = DEVICECONNECTEDSTRING
					self.setStatusLabelValue(DEVICECONNECTEDSTRING)
				else
					#$globals ["statusLabelString"] = DEVICEDISCONNECTEDSTRING
					self.setStatusLabelValue(DEVICEDISCONNECTEDSTRING)
				end # if deviceConnected
				#Say("startThread: new state: %s", $globals ["statusLabelString"])
			end # if device hat sich geändert
			
			# Wenn sich der String vom aktuellen String unterscheidet -> ändern
			#Say("statusLabelString: %s", $globals ["statusLabelString"])
#			if (oldStateString != $globals ["statusLabelString"]) then
#				#Say("Changing label...")
#				updateStatusLabel()
#				#@statusLabel.setStringValue_($globals ["statusLabelString"])
#			end 
			
			# Kucken wir in 5 Sekunden nochmal nach dem Rechten...
			sleep(THREADINTERVAL)  # Thread loops every some seconds
		end # loop do
	  end # thread do
	  @thread = nil
	end # if
end # def

def setStatusLabelValue(newValue)
	if ($globals ["statusLabelStringOld"] != newValue) then
		# Okay, neuer String!
		$globals ["statusLabelStringOld"] = $globals ["statusLabelString"]
		$globals ["statusLabelString"] = newValue
		
		# Wenn "Error" vorkommen -> rot einfärben des Textes im NSTextField!
		if (newValue.include?("rror")) then
			@statusLabel.setTextColor_(OSX::NSColor.redColor())
		else
			@statusLabel.setTextColor_(OSX::NSColor.blackColor())
		end
		
		# Update!
		@statusLabel.setStringValue_($globals ["statusLabelString"])
	end
end # setStatusLabelValue

## Alle Controls enablen oder disablen
#def updateStatusLabel()
##	if @newThread == nil then
# #	  $newThread = Thread.new do
#		# Status anzeigen
#		@statusLabel.setStringValue_($globals ["statusLabelString"])
##	  end # thread do
##	  @newThread = nil
##	end # if		
#end # updateStatusLabel

# deviceHasBeenDisconnected
def deviceHasBeenDisconnected
	Say("deviceHasBeenDisconnected...")
	$globals ["CachesDataSourceArray"].removeAllObjects
	$globals ["ImagesDataSourceArray"].removeAllObjects
	upperTableView.reloadData
	lowerTableView.reloadData
end # deviceHasBeenDisconnected

# deviceHasBeenConnected
def deviceHasBeenConnected
	Say("deviceHasBeenConnected...")
end # deviceHasBeenConnected

# Stoppen
def stopThread()
	Say("Stopping Thread.")
	@thread.kill if @thread
    @thread = nil
end # stopThread

# showPreferencesWindow
def showPreferencesWindow (sender)
    if @preferencesWindowController.nil? then
      @preferencesWindowController = PreferencesWindowController.alloc.init
    end
    @preferencesWindowController.showWindow(self)
end
ib_action :showPreferencesWindow


# Preferences lesen
def preferencesRead()
    # Preferences laden, ggf. auf Default setzen
#    # Oberes Textfeld
#	$globals["lastText"] = OSX::NSUserDefaults.standardUserDefaults.objectForKey("lastText")
#	if $globals['lastText'] == nil then
#		$globals['lastText'] = ""
#	end
#	# Popup Button
#	$globals["encodingPopupbuttonSetting"] = OSX::NSUserDefaults.standardUserDefaults.objectForKey("encodingPopupbuttonSetting")
#	if $globals['encodingPopupbuttonSetting'] == nil then
#		$globals['encodingPopupbuttonSetting'] = "ROT13"
#	end
end # preferencesRead

# Preferences in window anwenden
def preferencesApply()
#	# Oberes Textfeld
#	@upperTextfield.selectAll_:self	
#	@upperTextfield.insertText_($globals["lastText"])
#	# Popup Button
#	popupSelectionString=NSString.alloc.initWithCString_encoding_($globals['encodingPopupbuttonSetting'], NSASCIIStringEncoding)
#	@encodingPopupbutton.selectItemWithTitle_(popupSelectionString)
end # preferencesApply

def tableViewSelectionDidChange(aNotification)
	Say("tableViewSelectionDidChange")
	
	# Selection rausfinden und die Description TE updaten
	@indexset=@cachesTableView.selectedRowIndexes()
	
	if (@indexset.count > 1) then
		@cacheDetailTextView.setString_("More then one GPX selected. Please select only one to see its details.")
	elsif (@indexset.count > 0) then
		selectedrow=@indexset.firstIndex
		@dict=@cachesDataSource.objectAtIndex(selectedrow)
		@cacheDetailTextView.setString_(@dict.objectForKey("Description"))
	else
		@cacheDetailTextView.setString_("No GPX selected. Please select one to see its details.")
	end

end # tableViewSelectionDidChange



###############################################################################
# Private API #################################################################
private
#def Say(*args)
#    if (DEBUGAPPCONTROLLER==0) then return # Debugging ist aus -> raus hier
##    if ($globals['debug'].to_i==0) then return # Debugging ist aus -> raus hier
#	else
#		OSX::NSLog(*args)
#	end # else !debug
#end # Say
  
end # AppController
