#
#  Preferences Window.rb
#  GPSMinna
#
#  Created by Heiko on 17.08.08.
#  Copyright 2008 Heiko Kretschmer. All rights reserved.
#

# Requires
require 'osx/cocoa'
require 'Defines.rb'
require 'RobAnybody.rb' # Require here, so that it can be included below

####################################
# Subclass of "NSWindowController" #
class PreferencesWindowController < OSX::NSWindowController

####################################
# Includes (of Classes)            #
include		OSX
include		RobAnybody

####################################
# Outlets                          #
ib_outlets :statusLabel, :dividerDecimalTextfield, :mailboxPopup

def init
    initWithWindowNibName "PreferencesWindow"
    setWindowFrameAutosaveName "PreferencesWindow"
    return self
end

def windowDidLoad
	Say("windowDidLoad!")
    PreferencesLoad() # Prefs laden und ins GUI schreiben
end

def windowWillClose(notification)
	Say("windowWillClose!")
    preferencesWrite() # Prefs saven
end



# Private API
#  private

# PreferencesLoad
def PreferencesLoad
	Say("PreferencesLoad: Start")

	# Mailbox-Popup füllen NSPopup
	@mailboxPopup.removeAllItems()
	mailboxnames=geteverymailbox()
	mailboxnames.each_line("\r") { |line|
		line.chomp!
		if (line.length > 0) then
			Say("Adding %s to popup", line)
			@mailboxPopup.addItemWithTitle(line)
		end
	}

	# Mailbox Namen aus Preferences holen und prüfen
	Say("Setting mailboxName from defaults")
	mailboxName = getPreferencesMailboxName()

	# Selecten der Preferences
	@mailboxPopup.selectItemWithTitle(mailboxName)

	# Dezimal-Trenner aus Preferences holen und prüfen
	Say("Setting dividerDecimal from defaults")
	dividerDecimal = getPreferencesDecimalDivider()

	# Setzen des Wertes im TextField
	@dividerDecimalTextfield.stringValue=dividerDecimal.to_s

	Say("PreferencesLoad: End")
end # PreferencesLoad

# Methode: geteverymailbox.scpt
def geteverymailbox()
#	# Script-Path rausfinden
#	thisBundle	= OSX::NSBundle.mainBundle
#	tempfilepath='/tmp/gpsminna_geteverymailbox.tmp'
#	scriptPath = thisBundle.pathForResource_ofType("geteverymailbox", "scpt") # Mein AppleScript
#	Say("scriptPath: %s (%s)", scriptPath, scriptPath)

#	# Script ausführen
#	commandstring = "osascript " + scriptPath.to_s + ' > ' + tempfilepath
#	Say("commandstring: %@", commandstring)
#   system(commandstring)
#
#	# Script-Ergebnis abholen
#	r="Error: No URL!"
#	open (tempfilepath) do |f|  # File Operations in Ruby REALLY suck.
#		r = f.readline
#	end
#	system("rm " + tempfilepath)
#	
	
	r=""
	r=runScript("_geteverymailbox.scpt", "")
	
	Say("r: %s", r)
	return(r.to_s)
end # getSafariURL


# Preferences speichern
def preferencesWrite()
	defaults = OSX::NSUserDefaults.standardUserDefaults
	
	# Divider-Textfield
	defaults.setObject_forKey(@dividerDecimalTextfield.stringValue, "dividerDecimal")
	defaults.setObject_forKey(@mailboxPopup.selectedItem.title, "mailboxName")
	
    defaults.synchronize
end # preferencesWrite


##############################
# Private API ################
private

# Debugging-Ausgaben
#def Say(*args)
#    if (DEBUGPREFERENCESWINDOW==NO) then return # Debugging ist aus -> raus hier
#	else
#		OSX::NSLog(*args)
#	end # else !debug
#end # def Say

end # PreferencesWindowController
