#
#  RobAnybody.rb
#  GPSMinna
#
#  Created by Heiko on 2009-07-21
#  Copyright (c) 2009 Heiko Kretschmer. All rights reserved.
#

require 'osx/cocoa' # fuer RubyCocoa
#require 'Date'		# fuer DateTime
#require 'fileutils' # fuer File.exectable and friends
require 'Defines.rb'


####################################
# Klasse "RobAnybody"        #
#class RobAnybody < OSX::NSObject

module RobAnybody

#def Say(*args)
#	if (DEBUG==NO) then return # Debugging ist aus -> raus hier
#	else
#		OSX::NSLog(*args)
#	end # else !debug
#end # Say

# Methode: runScript
def runScript(scriptname, arg)
	r=""
	scriptPath="NOT_INITIALIZED"
	
	# Script-Path rausfinden
	Say("runScript launched!")
	Say("runScript: scriptname: %s", scriptname)
	Say("runScript: arg: %s", arg)
	# Erstmal in Bundle suchen ...
	scriptnamecomparray=scriptname.split('.')
	prefix = scriptnamecomparray[0]	# Filename
	suffix = scriptnamecomparray[1]	# Suffix
	Say("runScript: prefix: %s", prefix)
	Say("runScript: suffix: %s", suffix)
	scriptPath=getBundleResource(prefix, suffix)
	if (scriptPath)
		Say("scriptPath: %s", scriptPath)
	else
		# Wenn es nicht im App-Bundle lag, liegts vielleicht im Documents-Folder
		scriptPath = getUserFolder(FOLDERSCRIPTS) + "/" + scriptname
	end 
	Say("scriptPath: %s", scriptPath)
		
	if (scriptPath)
		Say("scriptPath is valid, will execute...")
		# Parameter rausfinden
		pathScripts	=	getUserFolder(FOLDERSCRIPTS)
		pathGPX		=	getUserFolder(FOLDERGPX)
		pathTracks	=	getUserFolder(FOLDERTRACKLOGS)
		pathImages	=	getUserFolder(FOLDERIMAGES)
		pathDeviceGPX	=	DEVICEGPXFOLDER
		pathResources	=	getResourcePath()
		decimalDivider	=	getPreferencesDecimalDivider()
		mailboxName		=	getPreferencesMailboxName()
		
		# Script ausführen: osascript + scriptPath + scriptsPath + gpxPath  + tracksPath + imagesPath + decimalDivider + mailboxName + arguments
		tempfilepath=pathScripts + '/.runScript.tmp'
		system("echo \"\" > " + tempfilepath)
		commandstring = "osascript \"" + scriptPath.to_s + "\" \"" + pathScripts + "\" \"" + pathGPX + "\" \"" + pathTracks + "\" \"" + pathImages + "\" \"" + pathDeviceGPX + "\" \"" + pathResources + "\" \"" + decimalDivider + "\" \"" + mailboxName + "\" " + arg + ' > ' + "\"" + tempfilepath + "\""
		Say("commandstring: %@", commandstring)
		system(commandstring)

#		# Script-Ergebnis als eine Zeile abholen
#		open (tempfilepath) do |f|  # File Operations in Ruby REALLY suck.
#			r = f.readline # http://ruby-doc.org/docs/ProgrammingRuby/html/ref_c_io.html
#		end
# doof, weil:  2009-12-22 21:13:53.910 GPSMinna[647:903] HIToolbox: ignoring exception 'end of file reached' that raised inside Carbon event dispatch

		# Script-Ergebnis als Array von Zeilen abholen
		f=open(tempfilepath) # File Operations in Ruby REALLY suck.
			r = f.readlines # http://ruby-doc.org/docs/ProgrammingRuby/html/ref_c_io.html
		system("rm " + tempfilepath)

	else
		Say("scriptPath is invalid, will not execute.")
	end
	
	Say("r: %s", r)
	
#	OSX::NSApplication().activateIgnoringOtherApps_(true)
	OSX::NSApplication.sharedApplication.activateIgnoringOtherApps_(true)
	
	return(r)
end # runScript

def getPreferencesMailboxName
    # Preferences Öffnen
	defaults = OSX::NSUserDefaults.standardUserDefaults

	mailboxName = defaults.objectForKey_("mailboxName")
	Say("mailboxName: %s", mailboxName)
	if mailboxName == nil then
		mailboxName = "" # Default passt fuer fuer english-sprachige Systeme
	end

	return (mailboxName)
end # getPreferencesMailboxName

def getPreferencesDecimalDivider
    # Preferences Öffnen
	defaults = OSX::NSUserDefaults.standardUserDefaults

	# Dezimal-Trenner aus Preferences holen und prüfen
	Say("Setting dividerDecimal from defaults")
	dividerDecimal = defaults.objectForKey("dividerDecimal")
	Say("dividerDecimal: %s", dividerDecimal)
	if dividerDecimal == nil then
		dividerDecimal = "." # Default passt fuer fuer english-sprachige Systeme
	end
	return (dividerDecimal)
end # getPreferencesDecimalDivider

# Get user's folder. Use following formats: FOLDERTRACKLOGS, FOLDERIMAGES, FOLDERGPX, FOLDERSCRIPTS
def getUserFolder(formatPathToFolder)
	username				=	OSX::NSUserName()
	@pathToFolder			=	OSX::NSMutableString.alloc.initWithString("")
	@pathToFolder.appendFormat(formatPathToFolder, username)
	Say("pathToFolder: %s", @pathToFolder.to_s)
	path = @pathToFolder.to_s
	return(path)
end # getUserFolder

def getBundleResource(filename, suffix)
	# Script und ähnliche-Resourcen Pfade rausfinden
	thisBundle	= OSX::NSBundle.mainBundle
	resourcePath = thisBundle.pathForResource_ofType(filename, suffix)
	Say("getBundleResource: resourcePath: %s", resourcePath)
	return(resourcePath)
end # getBundleResource

#def getUserScriptsPath()
#	username				=	OSX::NSUserName()
#	formatPathToFolder		=	FOLDERSCRIPTS
#	@pathToScriptsFolder	=	OSX::NSMutableString.alloc.initWithString("")
#	@pathToScriptsFolder.appendFormat(formatPathToFolder, username)
#	Say("pathToScriptsFolder: %s", @pathToScriptsFolder.to_s)
#	return(@pathToScriptsFolder.to_s)
#end # getUserScriptsPath

#def getUserGPXPath()
#	username				=	OSX::NSUserName()
#	formatPathToFolder		=	FOLDERGPX
#	@pathToFolder			=	OSX::NSMutableString.alloc.initWithString("")
#	@pathToFolder.appendFormat(formatPathToFolder, username)
#	Say("pathToScriptsFolder: %s", @pathToFolder.to_s)
#	return(@pathToFolder.to_s)
#end # getUserGPXPath


def getBundlePath()
	# Script und ähnliche-Resourcen Pfade rausfinden
	thisBundle	= OSX::NSBundle.mainBundle
	resourcePath = thisBundle.bundlePath
	Say("getBundlePath: resourcePath: %s", resourcePath)
	return(resourcePath)
end # getBundlePath

def getResourcePath()
	# Script und ähnliche-Resourcen Pfade rausfinden
	thisBundle	= OSX::NSBundle.mainBundle
	resourcePath = thisBundle.resourcePath
	Say("getResourcePath: resourcePath: %s", resourcePath)
	return(resourcePath)
end # getResourcePath

def getUsersHomeFolder()
	#thisBundle	= OSX::NSBundle.mainBundle
	username	= OSX::NSUserName()
	formatPathToFolder="/Users/%@" #/Documents/GPSMinna/Tracklogs" # Das hier vielleicht Customizebar machen? 
	@folderpath= OSX::NSMutableString.alloc.initWithString("")
	@folderpath.appendFormat(formatPathToFolder, username)
	Say("folderpath: %s", @folderpath.to_s)
	return(@folderpath)
end # def getUsersHomeFolder


# Inhalt einer URL als String zurückliefern.
def getURLContent(urlstring)
	# Script ausführen
	commandstring = "curl " + "\"" + urlstring.to_s + "\"" + ' --output /tmp/gpsminna_getURLContent.tmp'
	Say("commandstring: %@", commandstring)
    system(commandstring)

	# Script-Ergebnis abholen
	r="Error: No URL!"
	urlcontentfile = File.open('/tmp/gpsminna_getURLContent.tmp') # Nun mal nicht mit Kernel-IO sondern via File-Class. Mal sehen, ob das mögiger ist!
	#line = "Some Text Without Meaning!"
#	lines = ""
#	while (line = urlcontentfile.readline())
#		lines = lines.to_s + line
#	end # while
	linesarray = urlcontentfile.readlines()
	linesstring = linesarray.join('') #"\n")
	urlcontentfile.close
	system('/tmp/gpsminna_getURLContent.tmp')
	
	return(linesstring)
end # getURLContent


#def getSafariURL()
#	# Script-Path rausfinden
#	thisBundle	= OSX::NSBundle.mainBundle
#	scriptPath = thisBundle.pathForResource_ofType("getcurrenturlfromsafari", "scpt") # Mein AppleScript
#	Say("scriptPath: %s (%i)", scriptPath, scriptPath)
#
#	# Script ausführen
#	commandstring = "osascript " + scriptPath.to_s + ' > /tmp/gpsminna_getcurrenturlfromsafari.tmp'
#	Say("commandstring: %@", commandstring)
 #   system(commandstring)
#
#	# Script-Ergebnis abholen
#	r="Error: No URL!"
#	open ('/tmp/gpsminna_getcurrenturlfromsafari.tmp') do |f|  # File Operations in Ruby REALLY suck.
#		r = f.readline
#	end
#	system('rm /tmp/gpsminna_getcurrenturlfromsafari.tmp')
#	
#	return(r)
#end # getSafariURL


	def runScriptUsingDefaultInterpreterForSuffix(scriptName, args)
		
		# Interpreter bestimmen
		if scriptName.downcase.include? ".applescript" then
			interpreter = "osascript"
		elsif scriptName.downcase.include? ".scpt" then
			interpreter = "osascript"
		else
			interpreter = "" # Soll die Shell das regeln...
		end
	
		# Los!
		res = runScriptAndProcessMuchData(interpreter, scriptName, args)
	
		return(res)
	end # runScriptUsingDefaultInterpreterForSuffix


	def runScriptAndProcessMuchData(interpreter, scriptName, muchData)
		# Create temp file with our content
		tmpFile=createTempFile(muchData, "runScriptAndProcessMuchData")
		
		# Run the script
		res=runScriptWithParameter(interpreter, scriptName, "< \"" + tmpFile + "\"")
		
		# Clean up
	#	File.delete("\"" + tmpFile + "\"")
		File.delete(tmpFile)
		
		return(res)
	end # runScriptAndProcessMuchData


	# Script rennen lassen, args kann mehrere Argumente (mit whitespace getrennt) beinhalten
	def runScriptWithParameter(interpreter, scriptName, args)
		Say("Running script %s from bundle's folder...", scriptName)

		# Tempfile f. output erzeugen
		tmpFile=createTempFile("no result", "runScript")

		# Scriptpfad zusammenbauen
		resourcePath=self.getResourcePath + "/" + scriptName
		Say("resourcePath: %s", resourcePath)

			# Run the Script
			if (interpreter=="") then
				# Most likely a real command line tool, such as shell script
				command = "\"" + resourcePath + "\" " + args + " > \"" + tmpFile + "\"" 
			else
				# Most likely an applescript, needing osascript to execute
				command = interpreter + " \"" + resourcePath + "\" " + args + " > \"" + tmpFile + "\"" 
			end
			Say("command:" + command)
			commandResult = system(command)
			Say("commandResult: %s", commandResult)	
			
			# Nun das Zeug aus stdout-temp holen
			resultString=getFileAsString(tmpFile)
			Say("resultString: " + resultString)
			
		# Clean up
	#	File.delete("\"" + tmpFile + "\"")
		File.delete(tmpFile)

		Say("Running script from bundle's folder...done")
		return(resultString)
	end # runScriptWithParameter

	def getResourcePath()
		# Script und ähnliche-Resourcen Pfade rausfinden
		thisBundle	= OSX::NSBundle.mainBundle
		resourcePath = thisBundle.resourcePath
		Say("getResourcePath: resourcePath: %s", resourcePath)
		return(resourcePath)
	end # getResourcePath
		
	# Get user's folder. Use following formats: FOLDERTRACKLOGS, FOLDERIMAGES, FOLDERGPX, FOLDERSCRIPTS
	def getUserFolder(formatPathToFolder)
		username				=	OSX::NSUserName()
		@pathToFolder			=	OSX::NSMutableString.alloc.initWithString("")
		@pathToFolder.appendFormat(formatPathToFolder, username)
		Say("pathToFolder: %s", @pathToFolder.to_s)
		path = @pathToFolder.to_s
		return(path)
	end # getUserFolder

		
	# http://stackoverflow.com/questions/374431/how-do-i-get-the-default-temporary-directory-on-mac-os-x
	def createTempFile(content, callerName)
		Say("Creating new temp file...")
		tempDir = NSTemporaryDirectory();
		if (tempDir == nil)	then
			tempDir = "/tmp"
		end
		tempFile=tempDir + "/BurdaAdressbuchController_" + callerName + ".tmp"
		Say("Creating new temp file: " + tempFile)
		
		# http://snippets.dzone.com/posts/show/5051
		File.open(tempFile, 'w') {|f| f.write(content) }
		
		Say("Creating new temp file...DONE")
		return tempFile
	end # createTempFile


	def getFileAsString(filename)
	  data = ''
	  f = File.open(filename, "r") 
	  f.each_line do |line|
		data += line
	  end
	  return data
	end

	def Say(*args)
		if (DEBUGLOGGING!=true) then return # Debugging ist aus -> raus hier
		else
			msg = OSX::NSString.stringWithFormat_(*args).to_s
			OSX::NSLog("%s.%s: %s", calling_class(), calling_method(), msg)
	#OK		OSX::NSLog("%s: %s", calling_method(), msg)
	#OK		OSX::NSLog(*args)
		end # else !debug
	end # Say

	# http://www.ruby-forum.com/topic/75258
	def this_method 
		caller[0][/`([^']*)'/, 1]
	end

	# http://www.ruby-forum.com/topic/75258
	def calling_method
		caller[1] =~ /`([^']*)'/ and $1
	end

	# http://snippets.dzone.com/posts/show/4966
	def calling_class
		#line_item = LineItem.new
		#puts line_item.class.name.underscore.humanize.lowcase #spits out "line item"
		self.class.name
	end
	
end # of module RobAnybody




